clear
%clc
clf

%-----------------------System's parameters---------------------------%
Nof_nodes=5;
C_max=100;

s=512*8*ones(1,Nof_nodes);                                                              %service requirements parameters(in kBytes)
C=256*[1 1 2 2 4];                                                                      %the service rate of each node (in kbps)
%C=256*ceil(rand([1,Nof_nodes])*C_max);
L_max=(sum(C)/(s(1)*Nof_nodes))*ones(1,Nof_nodes);                                      %the max request birth rate from each node

%     C=256*ceil(rand([1,Nof_nodes])*C_max);                                                %the service rate of each node
%     L_max=8.8*ones(1,Nof_nodes);                                                            %the max request birth rate from each node

b=ones(1,Nof_nodes);                                                                    %holding costs (the Ci parameters in the lectures) 

rho_init=0.6;
rho_final=0.6;
step=0.1;
Nof_iters=floor((rho_final-rho_init)/step);

rho=zeros(1,Nof_iters);
E_glob_FIFO=zeros(1,Nof_iters);
E_prop_FIFO=zeros(1,Nof_iters);
E_eg_FIFO=zeros(1,Nof_iters);
E_alt_FIFO=zeros(1,Nof_iters);
E_glob_priority=zeros(1,Nof_iters);
E_prop_priority=zeros(1,Nof_iters);
E_eg_priority=zeros(1,Nof_iters);
E_alt_priority=zeros(1,Nof_iters);

e=0.0001;


%try_all_priorities(L,Nof_nodes,b,e)

hold on
for iter=0:Nof_iters  

    %------------------------Setup Phase----------------------------------%
    rho(iter+1)= rho_init+ step*iter; 
    L = rho(iter+1)*L_max;                                                              %the max request birth rate from each node

    lamda0=set_initial_splits(L,Nof_nodes,s,C)

    if(sum(sum(lamda0))==0)
        disp('System Unstable. Program exiting..')
        return
    end

    %------------------------Optimization---------------------------------%

    [l_glob_FIFO,D_glob_FIFO,E_glob_FIFO(iter+1)]=opt_global_FIFO(L,lamda0,Nof_nodes,s,C);
%     [l_eg_FIFO,D_eg_FIFO,E_eg_FIFO(iter+1)]=opt_egotistic_FIFO_wf(L,lamda0,Nof_nodes,s,C,e);
%     [l_alt_FIFO,D_alt_FIFO,E_alt_FIFO(iter+1)]=opt_altruistic_FIFO_wf(L,lamda0,Nof_nodes,s,C,e);
%     [l_prop_FIFO,D_prop_FIFO,E_prop_FIFO(iter+1)]=proportional_scheme_FIFO(L,Nof_nodes,s,C);
%     
%     [l_glob_priority,D_glob_priority,E_glob_priority(iter+1)]=opt_global_priority(L,lamda0,Nof_nodes,s,C);
%     [l_eg_priority,D_eg_priority,E_eg_priority(iter+1)]=opt_egotistic_priority_wf(L,lamda0,Nof_nodes,s,C,e);
%     [l_alt_priority,D_alt_priority,E_alt_priority(iter+1)]=opt_altruistic_priority_wf(L,lamda0,Nof_nodes,s,C,e);
%     [l_prop_priority,D_prop_priority,E_prop_priority(iter+1)]=proportional_scheme_priority(L,Nof_nodes,s,C);



%     %------------------PoA and Fairness Metrics---------------------------%
    
%     PA_eg_FIFO=E_eg_FIFO/E_glob_FIFO
%     IPA_eg_FIFO=D_eg_FIFO./D_glob_FIFO
%     Fair_eg_FIFO=(sum(L)^2)*(E_eg_FIFO^2)/(Nof_nodes*((L.^2)*(D_eg_FIFO.^2)'))
%     
%     PA_alt_FIFO=E_alt_FIFO/E_glob_FIFO
%     IPA_alt_FIFO=D_alt_FIFO./D_glob_FIFO
%     Fair_alt_FIFO=(sum(L)^2)*(E_alt_FIFO^2)/(Nof_nodes*((L.^2)*(D_alt_FIFO.^2)'))
%     
%     PA_eg_priority=E_eg_priority/E_glob_priority
%     IPA_eg_priority=D_eg_priority./D_glob_priority
%     Fair_eg_priority=(sum(L)^2)*(E_eg_priority^2)/(Nof_nodes*((L.^2)*(D_eg_priority.^2)'))
%     
%     PA_alt_priority=E_alt_priority/E_glob_priority
%     IPA_alt_priority=D_alt_priority./D_glob_priority
%     Fair_alt_priority=(sum(L)^2)*(E_alt_priority^2)/(Nof_nodes*((L.^2)*(D_alt_priority.^2)'))
    


end