function [lamda0] = set_initial_splits(L,Nof_nodes,s,C)
%   set_initial_splits splits the requests randomly

    lamda0=zeros(Nof_nodes);
    
    mean=split_proportionally(L,Nof_nodes,s,C);
    
    if ( sum( s*mean >=C ) )
        return;       
    end
    
    var=mean;

    while(1)
        for i=1:Nof_nodes-1
            for j=1:Nof_nodes-1
                lamda0(i,j)=normrnd(mean(i,j),var(i,j));                    %lamda(i,j)
            end
        end

        for i=1:Nof_nodes-1
            lamda0(i,Nof_nodes)=L(i)-sum(lamda0(i,:));                      %lamda(i,Nof_nodes)
        end

        for j=1:Nof_nodes-2                                                 %lamda(Nof_nodes,j)
            lamda0(Nof_nodes,j)=normrnd(mean(Nof_nodes,j),var(Nof_nodes,j));
        end

        lamda0(Nof_nodes,Nof_nodes-1)=L(Nof_nodes)-sum(lamda0(Nof_nodes,:));

        if(sum(sum(lamda0<0))==0 && sum((s*lamda0)>=C)==0)
            disp('Feasible random splits found');
            return;     
        end
        
        var=0.95*var;
        lamda0=zeros(Nof_nodes);
        
    end
       
end